use webcomment_common::types::*;

use serde::{Deserialize, Serialize};

#[derive(Clone, Debug, Default, Deserialize, Eq, PartialEq, Serialize)]
pub struct NotSentComment {
	pub author: String,
	pub email: String,
	pub text: String,
}

#[derive(Clone, Debug, Deserialize, Eq, PartialEq, Serialize)]
pub struct StoredComment {
	pub author: String,
	pub email: Option<String>,
	pub last_edit_time: Option<u64>,
	pub post_time: u64,
	pub text: String,
}

#[derive(Clone, Debug, Deserialize, Eq, PartialEq, Serialize)]
pub struct FullComment {
	pub author: String,
	pub email: Option<String>,
	pub id: CommentId,
	pub last_edit_time: Option<u64>,
	pub post_time: u64,
	pub text: String,
}
